//----------------------------------------------------------------------//
// ėpʊ֐															//
//																		//
//----------------------------------------------------------------------//
#include <vcl.h>
#pragma hdrstop
#include <tchar.h>
#include <mbstring.h>
#include <algorithm>
#include "UserFunc.h"

//---------------------------------------------------------------------------
#pragma package(smart_init)

//---------------------------------------------------------------------------
// wZp[^̑O̕擾
// Zp[^Ȃꍇ́Â܂ܕԂ
//---------------------------------------------------------------------------
UnicodeString get_tkn(UnicodeString s, UnicodeString sp)
{
	int p = s.Pos(sp);
	return (p==0)? s : s.SubString(1,p-1);
}
//---------------------------------------------------------------------------
// wZp[^̌̕擾
// Zp[^Ȃꍇ́AEmptyStr Ԃ
//---------------------------------------------------------------------------
UnicodeString get_tkn_r(UnicodeString s, UnicodeString sp)
{
	int p = s.Pos(sp);
	return (p==0)? EmptyStr : s.SubString(p+sp.Length(), s.Length()-(p-sp.Length()+1));
}

//---------------------------------------------------------------------------
// wZp[^O̕𕪗Ď擾
// Zp[^Ȃꍇ́Â܂ܕԂA͋
//---------------------------------------------------------------------------
UnicodeString split_tkn(UnicodeString &s, UnicodeString sp)
{
	UnicodeString r;
	int p = s.Pos(sp);
	if (p==0) {
		r = s;
		s = EmptyStr;
	}
	else {
		r = s.SubString(1,p-1);
		s = s.SubString(p+sp.Length(), s.Length()-(p-sp.Length()+1));
	}
	return r;
}

//---------------------------------------------------------------------------
//召ʂɕ (2oCgΉ)
//  wd: 
//   s: Ώە
//---------------------------------------------------------------------------
int pos_i(UnicodeString wd, UnicodeString s)
{
	if (wd.IsEmpty()) return 0;
	return s.UpperCase().Pos(wd.UpperCase());
}

//---------------------------------------------------------------------------
// | ؂胊XgɎwꂪ܂܂Ă邩H
//---------------------------------------------------------------------------
bool contains_word(UnicodeString lst, UnicodeString wd)
{
	if (!StartsStr("|", lst)) lst = "|" + lst;
	if (!EndsStr("|", lst))   lst += "|";
	return ContainsText(lst, "|"+wd+"|");
}

//---------------------------------------------------------------------------
//ppSpɕϊ
//---------------------------------------------------------------------------
UnicodeString to_zenstr(UnicodeString src)
{
	char *sbuf = new char[src.Length()*2+1];
	char *p = sbuf;
	for (int i=1; i<=src.Length(); i++) {
		if (StrByteType(src.c_str(), i-1) == mbSingleByte) {
			unsigned int c = _mbbtombc((unsigned int)src[i]);
			*p = (char)(c >> 8);	p++;
			*p = (char)(c & 0xff);	p++;
		}
		else {
			*p = src[i]; p++;
		}
	}
	*p = '\0';
	UnicodeString retstr = sbuf;
	delete [] sbuf;
	return retstr;
}

//---------------------------------------------------------------------------
// a`z ɂ\Lɕϊ
// a`z, aa`az, ba`bz...
//---------------------------------------------------------------------------
UnicodeString int_to_alpha(int n)
{
	UnicodeString retstr = EmptyStr;
	n--;
	if (n<0)
		retstr = "0";
	else {
		int n1 = n /26;
		if (n1>0) retstr += UnicodeString::StringOfChar((char)('a'+n1-1), 1);
		retstr += UnicodeString::StringOfChar((char)('a'+(n % 26)), 1);
	}
	return retstr;
}

//---------------------------------------------------------------------------
//(1`999)[}()ɕϊ
//---------------------------------------------------------------------------
UnicodeString int_to_roman(int n)
{
	UnicodeString retstr = EmptyStr;
	//100̈
	int rn = (n/100)%10;
	if (rn>0) {
		switch (rn) {
		case 1: case 2: case 3:
			retstr += UnicodeString::StringOfChar('c', rn); break;
		case 4: retstr += "cd"; break;
		case 5: retstr += "d";  break;
		case 6: case 7: case 8:
			retstr += ("d" + UnicodeString::StringOfChar('c', rn-5)); break;
		case 9: retstr += "cm"; break;
		}
	}

	//10̈
	rn = (n/10)%10;
	if (rn>0) {
		switch (rn) {
		case 1: case 2: case 3:
			retstr += UnicodeString::StringOfChar('x', rn); break;
		case 4: retstr += "xl"; break;
		case 5: retstr += "l";  break;
		case 6: case 7: case 8:
			retstr += ("l" + UnicodeString::StringOfChar('x', rn-5)); break;
		case 9: retstr += "xc"; break;
		}
	}

	//1̈
	rn = n%10;
	switch (rn) {
	case 1: case 2: case 3:
		retstr += UnicodeString::StringOfChar('i', rn); break;
	case 4: retstr += "iv"; break;
	case 5: retstr += "v";  break;
	case 6: case 7: case 8:
		retstr += ("v" + UnicodeString::StringOfChar('i', rn-5)); break;
	case 9: retstr += "ix"; break;
	}
	return retstr;
}

//---------------------------------------------------------------------------
//GXP[vɖ߂
//---------------------------------------------------------------------------
UnicodeString esc_to_str(UnicodeString src)
{
	src = ReplaceStr(src,"\\s",	" ");
	src = ReplaceStr(src,"\\t",	"\t");
	src = ReplaceStr(src,"\\n",	"\n");
	src = ReplaceStr(src,"\\r",	"\r");
	src = ReplaceStr(src,"\\\"",	"\"");
	return src;
}
//---------------------------------------------------------------------------
//ꕶGXP[vɕϊ
//---------------------------------------------------------------------------
UnicodeString str_to_esc(UnicodeString src)
{
	src = ReplaceStr(src," ",	"\\s");
	src = ReplaceStr(src,"\t",	"\\t");
	src = ReplaceStr(src,"\n",	"\\n");
	src = ReplaceStr(src,"\r",	"\\r");
	src = ReplaceStr(src,"\"",	"\\\"");
	return src;
}

//---------------------------------------------------------------------------
//SpXy[Xlg~O
//---------------------------------------------------------------------------
UnicodeString trim_ex(UnicodeString src)
{
	for (;;) {
		if (src.IsEmpty()) break;
		if (src.Pos("@")==1) {
			src.Delete(1,1); continue;
		}
		if ((src[1]==' ')||(src[1]=='\t')) {
			src.Delete(1,1); continue;
		}
		break;
	}
	for (;;) {
		if (src.IsEmpty()) break;
		int n = src.Length();
		if (n>1) {
			if (src.SubString(n-1,1)=="@") {
				src.Delete(n-1,1); continue;
			}
		}
		if ((src[n]==' ')||(src[n]=='\t')) {
			src.Delete(n,1); continue;
		}
		break;
	}
	return src;
}

//---------------------------------------------------------------------------
// " ݂̈͂O
//---------------------------------------------------------------------------
UnicodeString del_quot(UnicodeString s)
{
	if (s.Length()>=2 && StartsStr("\"", s) && EndsStr("\"", s))
		s = s.SubString(2, s.Length()-2);
	return s;
}

//---------------------------------------------------------------------------
// Xgɂĕu
// Xg:  TAB u
//---------------------------------------------------------------------------
UnicodeString replace_str_by_list(UnicodeString s, TStringList *lst)
{
	for (int i=0; i<lst->Count; i++) {
		UnicodeString t_s = lst->Strings[i];
		UnicodeString f_s = split_tkn(t_s, "\t");
		s = ReplaceStr(s, f_s, t_s);
	}
	return s;
}

//---------------------------------------------------------------------------
//fBNg̃}XNɊYSt@C擾
//  pnam: fBNg
//  mask: }XN
//   lst: ʂi[ TStrings
// subsw: TufBNg	(default = false);
//  subn: TufBNg̐[	(default = 99);
//---------------------------------------------------------------------------
void get_all_files(UnicodeString pnam, UnicodeString mask, TStrings *lst, bool subsw)
{
	if (pnam.IsEmpty()) return;
	if (!DirectoryExists(pnam)) return;
	pnam = IncludeTrailingPathDelimiter(pnam);
	if (mask.IsEmpty()) mask = "*.*";

	TSearchRec sr;
	UnicodeString tmpstr;
	//TufBNg
	if (subsw) {
		if (FindFirst(pnam+"*", faDirectory, sr) == 0) {
			do {
				if ((sr.Attr & faDirectory)==0) continue;
				if (sr.Name==".." || sr.Name==".") continue;
				get_all_files(pnam+sr.Name, mask, lst, subsw);
			} while (FindNext(sr) == 0);
			FindClose(sr);
		}
	}
	//t@C
	if (FindFirst(pnam+mask, faArchive|faNormal|faReadOnly, sr) == 0) {
		do {
			lst->Add(pnam+sr.Name);
		} while (FindNext(sr) == 0);
		FindClose(sr);
	}
}

//---------------------------------------------------------------------------
UnicodeString get_local_name(UnicodeString s)
{
	UnicodeString fnam = s;
	if (StartsText("file:///", fnam)) {
		fnam.Delete(1,8);
		fnam = ReplaceStr(fnam, "/", "\\");
		int p = fnam.Pos("#");
		if (p>0) fnam = fnam.SubString(1,p-1);
	}
	else
		fnam = EmptyStr;
	return fnam;
}

//---------------------------------------------------------------------------
//t@CHTMLH
//---------------------------------------------------------------------------
bool isHtml(UnicodeString fnam)
{
	if (StartsText("file:///", fnam)) fnam = get_local_name(fnam);
	return contains_word(".htm|.html|.sht|.shtm|.shtml|.php", ExtractFileExt(fnam).LowerCase());
}

//---------------------------------------------------------------------------
//fnam ɃhCuȂ
//st@C̃fBNg̑΃t@Cɕς
//t@C݂Ȃ false Ԃ
//---------------------------------------------------------------------------
bool get_file_name_r(UnicodeString &fnam)
{
	if (fnam.IsEmpty()) return false;
	if (ExtractFileDrive(fnam).IsEmpty()) fnam = ExtractFilePath(Application->ExeName) + fnam;
	return FileExists(fnam);
}

//---------------------------------------------------------------------------
// TUpDown Ɋ֘AÂĂҏW̒l`FbN
//---------------------------------------------------------------------------
bool check_TUpDown(TUpDown *udp)
{
	bool ret = true;
	if (udp->Associate) {
		_TCHAR tbuf[256];
		::GetWindowText(udp->Associate->Handle, tbuf, sizeof(tbuf)-1);
		UnicodeString tstr = tbuf;
		int n = tstr.ToIntDef(udp->Min-1);
		if ((n<udp->Min) || (n>udp->Max)) ret = false;
	}
	return ret;
}

//---------------------------------------------------------------------------
//AvP[Ṽo[W擾
// n.n.n.n  n.nn ɕϊ
//---------------------------------------------------------------------------
UnicodeString get_VersionStr(UnicodeString fnam)
{
	UnicodeString verstr;
	DWORD  dwReserved;
	DWORD  dwSize	= ::GetFileVersionInfoSize(fnam.c_str(), &dwReserved);
	LPVOID lpBuffer = ::HeapAlloc(::GetProcessHeap(), HEAP_ZERO_MEMORY, dwSize);
	if (lpBuffer) {
		if (::GetFileVersionInfo(fnam.c_str(), NULL, dwSize,lpBuffer)) {
			LPVOID lpLang = NULL;
			UINT   dwLength;
			if (::VerQueryValue(lpBuffer, _T("\\VarFileInfo\\Translation"), &lpLang, &dwLength)) {
				WORD *lpTranslate = (WORD*)lpLang;
				LPVOID lpStr;
				UnicodeString subblock;
				subblock.sprintf(_T("\\StringFileInfo\\%04x%04x\\FileVersion"), *lpTranslate, *(lpTranslate+1));
				if (::VerQueryValue(lpBuffer, subblock.c_str(), &lpStr, &dwLength))
					verstr.sprintf(_T("%s"), lpStr);
			}
		}
		::HeapFree(::GetProcessHeap(), 0, lpBuffer);
	}

	verstr = ReplaceStr(verstr, ".", EmptyStr).SubString(1, 3);
	if (verstr.Length()>=2) verstr.Insert(".", 2);
	return verstr;
}
//---------------------------------------------------------------------------
